{$A+,B-,F+,G+,N-,E-,P+,Q-,R-,T-,V+,X+}
{****************************************************************************
 * SoundLib 2 Module player - (c) 2000-2001 by Stefan Goehler               *
 * Copyright agreement in soundlib.txt - illegal copy without this file!    *
 * Version: 1.11                                                            *
 * Any bug reports and suggestions are welcome                              *
 * Complete package and new version always available here:                  *
 * http://sourcenet.home.pages.de                                           *
 ****************************************************************************}

{
  History:
    1.1:
    .added support for more than 8 channels (50 lines view)
    .added S3M support
    .variable sample information showpage
    .more settings available
    .better pausing - no hanging anymore
    .added XM support (err... better DON'T play 'em yet ;)

    1.11
    .fixed small displayment bug if samples had empty name
    .silent driver support - to play even if no hardware found
    .fixed problem with some MOD files concerning porta to note
    .extended by FPC support
    .fixed displayment bug for samples > 99999K
}

{$IFNDEF FPC}
uses snd_mod,drv_sb,drv_sil,stream32,crt,sndlib2,newfrontier,ports;
{$ELSE}
uses snd_mod,drv_sb,drv_sil,crt,sndlib2,objects,ports,go32;
{$ENDIF}
var
  tc,bc   : byte;
  module  : pmodule;
  fs3m    : ps3m;
  fmod    : pmod;
  fxm     : pxm;
  showpos : word;
  ysize   : word;
  intpol  : boolean;

const
  led1   : array[0..15] of byte=(0,0,0,0,128,128,128,128,128,128,128,128,0,0,0,0);
  led2   : array[0..15] of byte=(0,0,0,0,144,144,144,144,144,144,144,144,0,0,0,0);
  led3   : array[0..15] of byte=(0,0,0,0,146,146,146,146,146,146,146,146,0,0,0,0);
  char1  : array[0..15] of byte=(0,0,0,0,170,0,170,0,170,0,170,0,170,0,170,0);
  char2  : array[0..15] of byte=(0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,0);
  lo     : array[0..15] of byte=(255,255,192,192,192,192,192,192,192,192,192,192,192,192,192,192);
  ro     : array[0..15] of byte=(255,255,3,3,3,3,3,3,3,3,3,3,3,3,3,3);
  o      : array[0..15] of byte=(255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0);
  so     : array[0..15] of byte=(255,255,24,24,24,24,24,24,24,24,24,24,24,24,24,24);
  s      : array[0..15] of byte=(24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24);
  lu     : array[0..15] of byte=(192,192,192,192,192,192,192,192,192,192,192,192,192,192,255,255);
  ru     : array[0..15] of byte=(3,3,3,3,3,3,3,3,3,3,3,3,3,3,255,255);
  u      : array[0..15] of byte=(0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255);
  su     : array[0..15] of byte=(24,24,24,24,24,24,24,24,24,24,24,24,24,24,255,255);
  sr     : array[0..15] of byte=(3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3);
  sl     : array[0..15] of byte=(192,192,192,192,192,192,192,192,192,192,192,192,192,192,192,192);

  led1_50  : array[0..7] of byte=(0,128,128,128,128,128,128,0);
  led2_50  : array[0..7] of byte=(0,144,144,144,144,144,144,0);
  led3_50  : array[0..7] of byte=(0,146,146,146,146,146,146,0);
  char1_50 : array[0..7] of byte=(0,170,0,170,0,170,0,170);
  char2_50 : array[0..7] of byte=(0,255,255,255,255,255,255,255);
  lo_50    : array[0..7] of byte=(255,255,192,192,192,192,192,192);
  ro_50    : array[0..7] of byte=(255,255,3,3,3,3,3,3);
  o_50     : array[0..7] of byte=(255,255,0,0,0,0,0,0);
  so_50    : array[0..7] of byte=(255,255,24,24,24,24,24,24);
  s_50     : array[0..7] of byte=(24,24,24,24,24,24,24,24);
  lu_50    : array[0..7] of byte=(192,192,192,192,192,192,255,255);
  ru_50    : array[0..7] of byte=(3,3,3,3,3,3,255,255);
  u_50     : array[0..7] of byte=(0,0,0,0,0,0,255,255);
  su_50    : array[0..7] of byte=(24,24,24,24,24,24,255,255);
  sr_50    : array[0..7] of byte=(3,3,3,3,3,3,3,3);
  sl_50    : array[0..7] of byte=(192,192,192,192,192,192,192,192);

procedure TextColor(Color: Byte);
begin
  tc := color;
  crt.textcolor(color);
end;

procedure TextBackground(Color: Byte);
begin
  bc := color;
  crt.textbackground(color);
end;

procedure writexy(x,y : integer;s : string);
var
  i : integer;
  color : word;
begin
  color := (tc+bc shl 4) shl 8;
  dec(x,2);dec(y);
  for i := 1 to length(s) do memw[segB800:(y*80+x)*2+i*2] := ord(s[i])+color;
end;

procedure hidecursor;
begin
  gotoxy(1,1);
end;

procedure frame(x,y,sx,sy : integer);
const
  frames : array[1..9] of char = ('','','','','','','','','');

var
  lx,ly : integer;
  s     : string;

begin
  textcolor(white);
  textbackground(blue);
  s := frames[1];
  for lx := 1 to sx-2 do s := s + frames[5];
  s := s + frames[2];
  gotoxy(x,y);
  write(s);
  for ly := 1 to sy-2 do
  begin
    s := frames[7];
    for lx := 1 to sx-2 do s := s + ' ';
    s := s + frames[8];
    gotoxy(x,y+ly);
    write(s);
    textcolor(lightgray);
    textbackground(black);
    write('');
    textbackground(blue);
    textcolor(white);
  end;
  s := frames[4];
  for lx := 1 to sx-2 do s := s + frames[9];
  s := s + frames[3];
  gotoxy(x,y+sy-1);
  write(s);
  s := '';
  textcolor(lightgray);
  textbackground(black);
  write('');
  for lx := 1 to sx do s := s + '';
  gotoxy(x+2,y+sy);
  write(s);
  textbackground(blue);
  hidecursor;
end;

procedure cls;
var
  i : integer;

begin
  textbackground(blue);
  textcolor(blue);
  clrscr;
  textcolor(white);
  textbackground(lightgray);
  gotoxy(1,2);
  write('');
  textcolor(lightgray);
  textbackground(black);
  write('');textcolor(lightgray);
  textcolor(white);
  textbackground(lightgray);
  gotoxy(1,3);
  for i := 1 to ysize-3 do write('');
  textcolor(white);
  textbackground(blue);
  writexy(4,1,'MOD-Player, (c) 2000 by Stefan Ghler, Germany - uses '+sl_versionstr);
  writexy(13,ysize,'Take a look at my Website: http://sourcenet.home.pages.de');
  hidecursor;
end;

procedure setchar(ch : char;var data);
var
  count : word;

begin
  if (ysize = 50) then count := 8 else count := 16;
  outpw($03c4,$0402);
  outpw($03c4,$0704);
  outpw($03ce,$0204);
  outpw($03ce,$0005);
  outpw($03ce,$0006);
  {$IFNDEF FPC}
  move(data,ptr(segA000,ord(ch) shl 5)^,count);
  {$ELSE}
  dosmemput(segA000,ord(ch) shl 5,data,count);
  {$ENDIF}
  outpw($03c4,$0302);
  outpw($03c4,$0304);
  outpw($03ce,$0004);
  outpw($03ce,$1005);
  outpw($03ce,$0e06);
end;

procedure showvu(x,y,size : word);
var
  i : integer;
  s : string;
begin
  s := '';
  textcolor(lightcyan);
  textbackground(black);
  fillchar(s[1],17,32);
  fillchar(s[1],size div 3,'');
  case size mod 3 of
    1 : s[size div 3+1] := '';
    2 : s[size div 3+1] := '';
  end;
  s[0] := #13;
  writexy(x,y,s);
  textcolor(lightred);
  s[0] := #17;
  delete(s,1,13);
  writexy(x+13,y,s);
end;

function inttostr(l,width : longint) : string;
{ convert longint to string }
var
  c : string[20];
begin
  str(l:width,c);
  inttostr := c;
end;

var
  chvol    : array[0..31] of byte;
  sb       : psoundblaster;
  silent   : psilent;
  driver   : psounddriver;
  c        : char;
  {$IFNDEF FPC}
  fm       : tfilestream32;
  {$ELSE}
  fm       : tdosstream;
  {$ENDIF}
  vol      : word;

procedure showinfo(var m : tmodule);
var
  i,ch : integer;
  s    : string;
  vu   : byte;

begin
  textcolor(white);
  textbackground(blue);
  writexy(36,9,'Pattern: '+inttostr(m.actpattern+1,3)+'/'+inttostr(m.songlength,0));
  writexy(67,9,'Line: '+inttostr(m.actline,3));

  writexy(36,6,'Speed     : '+inttostr(m.tempo,2)+' at '+inttostr(m.bpm,3)+' bpm');
  if (vol > 256) then s := ' (amplified)' else s := '            ';
  writexy(36,7,'Volume    : '+inttostr(vol,3)+s);

  s := '';
  for i := 1 to round(m.getpos/m.getsize*40) do s := s+'';
  for i := round(m.getpos/m.getsize*40) to 39 do s := s+'';
  writexy(36,10,s);

  for ch := 0 to m.playchnls-1 do
  begin
    { VU meters }
    vu := m.cs.channel[ch].sound.getvu;
    chvol[ch] := round((vu*2+chvol[ch])/3);

    i := round(chvol[ch]/255*48*3/2);
    if i > 48 then i := 48;
    showvu(10,showpos+ch,i);
    { Frequency }

    if (m.cs.channel[ch].sound.isplaying) then
    begin
      textcolor(white);
      textbackground(black);
      writexy(6,showpos+ch,' '+inttostr(m.cs.channel[ch].voice,2)+' ');
      textcolor(white);
      textbackground(blue);
      writexy(28,showpos+ch,m.cs.instrument[m.cs.channel[ch].voice].name);
      writexy(53,showpos+ch,inttostr(m.cs.channel[ch].sound.data.freq,6));
    end else
    begin
      textcolor(white);
      textbackground(black);
      writexy(6,showpos+ch,'    ');
      textcolor(white);
      textbackground(blue);
      writexy(28,showpos+ch,'                               ');
    end;

    { Effect    }
    case m.cs.channel[ch].lasteffect and $FF of
      $00 : writexy(60,showpos+ch,'arpeggio         ');
      $01 : writexy(60,showpos+ch,'portamento up    ');
      $02 : writexy(60,showpos+ch,'portamento down  ');
      $03 : writexy(60,showpos+ch,'porta to note    ');
      $04 : writexy(60,showpos+ch,'vibrato          ');
      $05 : writexy(60,showpos+ch,'porta+vol slide  ');
      $06 : writexy(60,showpos+ch,'vibrato+vol slide');
      $07 : writexy(60,showpos+ch,'tremolo          ');
      $08 : writexy(60,showpos+ch,'panning          ');
      $09 : writexy(60,showpos+ch,'set sample ofs   ');
      $0A,$F6 : writexy(60,showpos+ch,'volume slide     ');
      $0B : writexy(60,showpos+ch,'position jump    ');
      $0C : writexy(60,showpos+ch,'volume change    ');
      $0D : writexy(60,showpos+ch,'pattern break    ');
      $0E : case (m.cs.channel[ch].lasteffect shr 12) of
              $00 : writexy(60,showpos+ch,'set filter       ');
              $01 : writexy(60,showpos+ch,'fine porta up    ');
              $02 : writexy(60,showpos+ch,'fine porta down  ');
              $04 : writexy(60,showpos+ch,'vibrato waveform ');
              $05 : writexy(60,showpos+ch,'set finetune     ');

              $07 : writexy(60,showpos+ch,'tremelo waveform ');
              $08 : writexy(60,showpos+ch,'panning          ');
              $09 : writexy(60,showpos+ch,'retrigger note   ');
              $0A : writexy(60,showpos+ch,'fine vol slide up');
              $0B : writexy(60,showpos+ch,'fine vol slide dn');
              $0C : writexy(60,showpos+ch,'cut note         ');
              $0D : writexy(60,showpos+ch,'note delay       ');
              $0E : writexy(60,showpos+ch,'pattern delay    ');
              else writexy(60,showpos+ch,'WC ('+inttostr(m.cs.channel[ch].lasteffect shr 12,2)+')       ');
            end;
      $0F : writexy(60,showpos+ch,'speed change     ');
      $10 : writexy(60,showpos+ch,'set global volume');
      $1B : writexy(60,showpos+ch,'retrig+vol slide ');
      $1D : writexy(60,showpos+ch,'tremor           ');
      $21 : case (m.cs.channel[ch].lasteffect shr 8) and $F of
              $01,$02 : writexy(60,showpos+ch,'extra fine porta ');
            end;
      $F4 : writexy(60,showpos+ch,'fine vibrato     ');
      $F5 : writexy(60,showpos+ch,'set speed        ');
      $FF : writexy(60,showpos+ch,'                 ');
      else writexy(60,showpos+ch,'unimpl ('+inttostr(m.cs.channel[ch].lasteffect and $FF,0)+')');
    end;
  end;
end;

procedure showsongdata(var m : tmodule);
var
  s   : string;

begin
  textcolor(white);
  if (driver^.data.flags and snd_stereo <> 0) then s := 'Stereo' else s := 'Mono';

  writexy(36,4,'Frequency : '+inttostr(driver^.data.freq,0)+' Hz, '+s);
  writexy(36,5,'Song name : '+m.songname);

  textcolor(lightgray);
  writexy(7,showpos-1,'Nr        VU                 Sample               Hz       Effect');
end;

procedure mainpage;
begin
  cls;
  frame(4,3,74,9);

  frame(4,showpos-2,74,module^.playchnls+3);
  writexy(6,4,'ESC: Exit');
  writexy(6,5,'P  : Pause');
  writexy(6,6,'-/+: Volume change');
  writexy(6,7,'S  : Show sample info');
  writexy(6,8,'I  : Toggle sample interpol.');
  writexy(6,9,#27#26' : Slow seek');
  writexy(6,10,#24#25' : Fast seek');

  showsongdata(module^);
end;

procedure showsampleinfo;
var
  pos,max : integer;

procedure showsamples(start : word);
var
  i,j : integer;
  s   : string;

begin
  if (start > 1) then textcolor(white) else textcolor(lightgray);
  writexy(76,5,#24);
  writexy(76,6,#24);

  if (start < module^.instruments-max)and(module^.instruments > max+1) then textcolor(white) else textcolor(lightgray);
  writexy(76,ysize-5,#25);
  writexy(76,ysize-4,#25);
  textcolor(white);
  for i := start to start+max do if (i <= module^.instruments) then
  begin
    s := module^.cs.instrument[i].name;
    if (s = '') then s := '                              ';

    writexy(6,5+i-start,inttostr(i,2)+'   '+
                s+'    ');

    writexy(40,5+i-start,inttostr(module^.cs.instrument[i].size,6)+'     '+
                inttostr(module^.cs.instrument[i].volume,2)+'     '+
                inttostr(module^.cs.instrument[i].loopstart,6)+' - '+
                inttostr(module^.cs.instrument[i].loopend,6));
  end;
end;

begin
  cls;
  max := ysize-9;
  frame(4,3,74,max+4);
  textcolor(lightgray);
  writexy(6,4,'##   Name                           Size   Volume        Repeat');
  textcolor(white);
  pos := 1;
  showsamples(pos);
  repeat
    if keypressed then c := readkey else c := #1;
    if (c = #0) then
    begin
      c := readkey;
      case c of
        'H' : if (pos > 1) then dec(pos);
        'P' : if (pos < integer(module^.instruments)-max) then inc(pos);
        #71 : pos := 1;
        #79 : if (module^.instruments > max) then pos := module^.instruments-max else pos := 1;
        #73 : if (pos > max) then dec(pos,max) else pos := 1;
        #81 : if (module^.instruments > max) then
              begin
                 inc(pos,max);
                 if (pos > integer(module^.instruments)-max) then
                 pos := integer(module^.instruments)-max;
              end;
        else;
      end;
      showsamples(pos);
      end;
  until (c = #27)or(c = #13)or(upcase(c) = 'S');
  c := #1;
end;

begin
  { Check commandline parameters }
  if (paramcount = 0) then
  begin
    writeln('SoundLib 2 Module file player; (c) 2000-2001 by Stefan Goehler');
    writeln;
    writeln('Usage: MODPLAY [FILE]');
    writeln('FILE: any MOD, S3M or XM-file');
    writeln('Warning! XM playback buggy yet!');
    halt;
  end;

  { Initialize sound driver }
  new(sb,init(0));
  if (sb = nil)or(not sb^.startplayback(0,snd_auto)) then
  begin
    { Init silent driver WITH interrupt calls }
    new(silent,init(true));
    silent^.startplayback(0,snd_auto);
    writeln('Soundblaster driver initialization failed, using silent driver');
    writeln('You won''t hear any sound, you''ll just see the displayment');
    writeln;
    writeln('Press any key to continue...');
    readkey;
    driver := silent;
  end
  else driver := sb;

  if (not fm.init(paramstr(1),stopenread)) then
  begin
    writeln('Could not open source file');
    driver^.free;
    halt;
  end;

  { Try to find the format of the file }
  new(fs3m,init(driver^,fm));
  if (fs3m <> nil) then
  begin
    module := fs3m;
  end else
  begin
    fm.reset;
    fm.seek(0);
    new(fmod,init(driver^,fm));
    if (fmod <> nil) then module := fmod else
    begin
      fm.reset;
      fm.seek(0);
      new(fxm,init(driver^,fm));
      module := fxm;
    end;
  end;

  { If no supported file type found, exit }
  if (not assigned(module)) then
  begin
    clrscr;
    writeln('SoundLib 2 Module file player; (c) 2000-2001 by Stefan Goehler');
    writeln;
    writeln('Error: Could not open module file');
    driver^.free;
    halt;
  end;

  fm.done;

  { Update character set to the new displayment }
  if (module^.playchnls > 8) then
  begin
    textmode(co80+font8x8);
    ysize := 50;
    setchar('',led1_50);
    setchar('',led2_50);
    setchar('',led3_50);
    setchar('',char1_50);
    setchar('',char2_50);
    setchar('',lo_50);
    setchar('',o_50);
    setchar('',so_50);
    setchar('',s_50);
    setchar('',ro_50);
    setchar('',lu_50);
    setchar('',ru_50);
    setchar('',su_50);
    setchar('',u_50);
    setchar('',sl_50);
    setchar('',sr_50);
  end else
  begin
    textmode(co80);
    ysize := 25;
    setchar('',led1);
    setchar('',led2);
    setchar('',led3);
    setchar('',char1);
    setchar('',char2);
    setchar('',lo);
    setchar('',o);
    setchar('',so);
    setchar('',s);
    setchar('',ro);
    setchar('',lu);
    setchar('',ru);
    setchar('',su);
    setchar('',u);
    setchar('',sl);
    setchar('',sr);
  end;

  showpos := (ysize-module^.playchnls) div 2+7;

  mainpage;
  hidecursor;
  module^.play;

  vol := 256;
  repeat
    if (module^.change) then showinfo(module^);
    if keypressed then c := readkey else c := #1;
    case upcase(c) of
      'P': module^.pause;
      '-','+': begin
                 if (c = '-')and(vol > 3) then dec(vol,4);
                 if (c = '+')and(vol < 509) then inc(vol,4);
                 module^.setvolume(0,vol);
                 module^.setvolume(1,vol);
               end;
      'S': begin
             showsampleinfo;
             mainpage;
           end;

      #0 : begin
              c := readkey;
              case c of
                'H' : module^.setpos(module^.getpos+16);
                'P' : module^.setpos(module^.getpos-16);
                'M' : module^.setpos(module^.getpos+2);
                'K' : module^.setpos(module^.getpos-3);
              end;
           end;
      'I': begin { Set interpolation }
             intpol := not intpol;
             module^.setinterpolation(intpol);
           end;
    end;
  until {(c = #45)or}(c = #27)or((not module^.isplaying)and(not module^.ispaused));

  while keypressed do readkey;

  module^.free;
  driver^.free;

  textmode(3);
  writeln('SoundLib 2 module player');
  writeln;
  writeln('Get the newest version at http://sourcenet.home.pages.de');
  writeln('Any comments or bug reports? Mail me: stefan.goehler@gmx.de');
end.
