;SoundLib 2 sound format conversion routines
;(c) 2000-2001 by Stefan Goehler

;!! = procedures or parts which are untested yet or/and have bugs or aren't
;finished yet

.model large,pascal
.386p
.data

public sat32
public aud_us8_to_s16
public aud_s8_to_s16
public aud_us16_to_s16

;These routines only support saturated sound data coming from the mixer

public aud_s32_to_ds8
public aud_s32_to_dus8
public aud_s32_to_ds16
public aud_s32_to_dus16

public aud_s32_to_s16
public aud_s32_to_sm16
public aud_s32_to_us16
public aud_s32_to_usm16
public aud_s32_to_s8
public aud_s32_to_sm8
public aud_s32_to_us8
public aud_s32_to_usm8

public delta8_to_16
public delta16_to_16

ends

.code

sat32 proc
arg data:pword,samples:dword
  les   edi,data
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32

@lp_s32:
  mov   eax,es:[edi]
  cmp   eax,1FFFFFFFh
  jng   @na1_s32
    mov   eax,1FFFFFFFh
    jmp   @out_s32
  @na1_s32:
  cmp   eax,0E0000001h
  jnl   @na2_s32
    mov   eax,0E0000001h
  @na2_s32:

@out_s32:
  add   eax,eax
  mov   es:[edi],eax

  add   edi,4
  dec   ecx
  jnz   @lp_s32
@end_s32:
  ret
sat32 endp

aud_us8_to_s16 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_us8

  mov   dx,ds
  lds   esi,dest
@lp_us8:
  mov   al,0
  mov   ah,es:[edi]
  sub   ax,32768
  mov   ds:[esi],ax
  add   esi,2
  inc   edi
  dec   ecx
  jnz   @lp_us8
  mov   ds,dx
@end_us8:
  ret
aud_us8_to_s16 endp

aud_s8_to_s16 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s8

  mov   dx,ds
  lds   esi,dest
  mov   al,0
@lp_s8:
  mov   ah,es:[edi]
  mov   ds:[esi],ax
  add   esi,2
  inc   edi
  dec   ecx
  jnz   @lp_s8
  mov   ds,dx
@end_s8:
  ret
aud_s8_to_s16 endp

aud_us16_to_s16 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_us16

  mov   dx,ds
  lds   esi,dest
@lp_us16:
  mov   al,0
  mov   ax,es:[edi]
  sub   ax,32768
  mov   ds:[esi],ax
  add   esi,2
  add   edi,2
  dec   ecx
  jnz   @lp_us16
  mov   ds,dx
@end_us16:
  ret
aud_us16_to_s16 endp

aud_s32_to_ds8 proc
arg source1:pword,source2:pword,dest:pword,samples:dword
  les   edi,source1
  les   edx,source2
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32ds8

  push  ds
  lds   esi,dest
@lp_s32ds8:
  mov   eax,es:[edi]
  mov   ebx,es:[edx+8]
  sub   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32ds8_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32ds8_1
  @na_s32ds8_1:
  cmp   eax,0E0000001h
  jnl   @out_s32ds8_1
    mov   eax,0E0000001h
@out_s32ds8_1:
  add   eax,eax
  shr   eax,24
  mov   ds:[esi],al

  mov   eax,es:[edi+4]
  add   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32ds8_2
    mov   eax,1FFFFFFFh
    jmp   @out_s32ds8_2
  @na_s32ds8_2:
  cmp   eax,0E0000001h
  jnl   @out_s32ds8_2
    mov   eax,0E0000001h
@out_s32ds8_2:
  add   eax,eax
  shr   eax,24
  mov   ds:[esi+1],al

  add   edi,12
  add   edx,12
  add   esi,2
  dec   ecx
  jnz   @lp_s32ds8
  pop   ds
@end_s32ds8:
  ret
aud_s32_to_ds8 endp

aud_s32_to_dus8 proc
arg source1:pword,source2:pword,dest:pword,samples:dword
  les   edi,source1
  les   edx,source2
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32du8

  push  ds
  lds   esi,dest
@lp_s32du8:
  mov   eax,es:[edi]
  mov   ebx,es:[edx+8]
  sub   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32du8_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32du8_1
  @na_s32du8_1:
  cmp   eax,0E0000001h
  jnl   @out_s32du8_1
    mov   eax,0E0000001h
@out_s32du8_1:
  add   eax,eax
  shr   eax,24
  add   al,128
  mov   ds:[esi],al

  mov   eax,es:[edi+4]
  add   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32du8_2
    mov   eax,1FFFFFFFh
    jmp   @out_s32du8_2
  @na_s32du8_2:
  cmp   eax,0E0000001h
  jnl   @out_s32du8_2
    mov   eax,0E0000001h
@out_s32du8_2:
  add   eax,eax
  shr   eax,24
  add   al,128
  mov   ds:[esi+1],al

  add   edi,12
  add   edx,12
  add   esi,2
  dec   ecx
  jnz   @lp_s32du8
  pop   ds
@end_s32du8:
  ret
aud_s32_to_dus8 endp

aud_s32_to_ds16 proc
arg source1:pword,source2:pword,dest:pword,samples:dword
  les   edi,source1
  les   edx,source2
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32ds16

  push  ds
  lds   esi,dest
@lp_s32ds16:
  mov   eax,es:[edi]
  mov   ebx,es:[edx+8]
  sub   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32d16_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32d16_1
  @na_s32d16_1:
  cmp   eax,0E0000001h
  jnl   @out_s32d16_1
    mov   eax,0E0000001h
@out_s32d16_1:
  add   eax,eax
  shr   eax,16
  mov   ds:[esi],ax

  mov   eax,es:[edi+4]
  add   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32d16_2
    mov   eax,1FFFFFFFh
    jmp   @out_s32d16_2
  @na_s32d16_2:
  cmp   eax,0E0000001h
  jnl   @out_s32d16_2
    mov   eax,0E0000001h
@out_s32d16_2:
  add   eax,eax
  shr   eax,16
  mov   ds:[esi+2],ax

  add   edi,12
  add   edx,12
  add   esi,4
  dec   ecx
  jnz   @lp_s32ds16
  pop   ds
@end_s32ds16:
  ret
aud_s32_to_ds16 endp

aud_s32_to_dus16 proc
arg source1:pword,source2:pword,dest:pword,samples:dword
  les   edi,source1
  les   edx,source2
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32du16

  push  ds
  lds   esi,dest
@lp_s32du16:
  mov   eax,es:[edi]
  mov   ebx,es:[edx+8]
  sub   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32du16_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32du16_1
  @na_s32du16_1:
  cmp   eax,0E0000001h
  jnl   @out_s32du16_1
    mov   eax,0E0000001h
@out_s32du16_1:
  add   eax,eax
  shr   eax,16
  add   ax,32768
  mov   ds:[esi],ax

  mov   eax,es:[edi+4]
  add   eax,ebx
  cmp   eax,1FFFFFFFh
  jng   @na_s32du16_2
    mov   eax,1FFFFFFFh
    jmp   @out_s32du16_2
  @na_s32du16_2:
  cmp   eax,0E0000001h
  jnl   @out_s32du16_2
    mov   eax,0E0000001h
@out_s32du16_2:
  add   eax,eax
  shr   eax,16
  add   ax,32768
  mov   ds:[esi+2],ax

  add   edi,12
  add   edx,12
  add   esi,4
  dec   ecx
  jnz   @lp_s32du16
  pop   ds
@end_s32du16:
  ret
aud_s32_to_dus16 endp

aud_s32_to_s16 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s3216

  mov   dx,ds
  lds   esi,dest
@lp_s3216:
  mov   eax,es:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_s3216
    mov   eax,1FFFFFFFh
    jmp   @out_s3216
  @na_s3216:
  cmp   eax,0E0000001h
  jnl   @out_s3216
    mov   eax,0E0000001h
@out_s3216:
  add   eax,eax

  shr   eax,16
  mov   ds:[esi],ax
  add   edi,4
  add   esi,2
  dec   ecx
  jnz   @lp_s3216
  mov   ds,dx
@end_s3216:
  ret
aud_s32_to_s16 endp

aud_s32_to_sm16 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32m16

  mov   dx,ds
  lds   esi,dest
@lp_s32m16:
  mov eax,es:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_s32m16_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32m16_1
  @na_s32m16_1:
  cmp   eax,0E0000001h
  jnl   @out_s32m16_1
    mov   eax,0E0000001h
@out_s32m16_1:

  mov ebx,es:[edi+4]

  cmp   ebx,1FFFFFFFh
  jng   @na_s32m16_2
    mov   ebx,1FFFFFFFh
    jmp   @out_s32m16_2
  @na_s32m16_2:
  cmp   ebx,0E0000001h
  jnl   @out_s32m16_2
    mov   ebx,0E0000001h
@out_s32m16_2:

  add   eax,ebx
  shr   eax,16
  mov   ds:[esi],ax
  add   edi,8
  add   esi,2
  dec   ecx
  jnz   @lp_s32m16
  mov   ds,dx
@end_s32m16:
  ret
aud_s32_to_sm16 endp

aud_s32_to_us16 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32u16

  mov   dx,ds
  lds   esi,dest
@lp_s32u16:
  mov   eax,es:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_us3216
    mov   eax,1FFFFFFFh
    jmp   @out_us3216
  @na_us3216:
  cmp   eax,0E0000001h
  jnl   @out_us3216
    mov   eax,0E0000001h
@out_us3216:
  add   eax,eax
  shr   eax,16

  add   ax,32768
  mov   ds:[esi],ax
  add   edi,4
  add   esi,2
  dec   ecx
  jnz   @lp_s32u16
  mov   ds,dx
@end_s32u16:
  ret
aud_s32_to_us16 endp

aud_s32_to_usm16 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32um16

  mov   dx,ds
  lds   esi,dest
  xor   eax,eax
  xor   ebx,ebx
@lp_s32um16:
  mov   eax,es:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_us32m16_1
    mov   eax,1FFFFFFFh
    jmp   @out_us32m16_1
  @na_us32m16_1:
  cmp   eax,0E0000001h
  jnl   @out_us32m16_1
    mov   eax,0E0000001h
@out_us32m16_1:

  mov ebx,es:[edi+4]

  cmp   ebx,1FFFFFFFh
  jng   @na_us32m16_2
    mov   ebx,1FFFFFFFh
    jmp   @out_us32m16_2
  @na_us32m16_2:
  cmp   ebx,0E0000001h
  jnl   @out_us32m16_2
    mov   ebx,0E0000001h
@out_us32m16_2:

  add   eax,ebx
  shr   eax,16
  add   ax,8000h

  mov   ds:[esi],ax
  add   edi,8
  add   esi,2
  dec   ecx
  jnz   @lp_s32um16
  mov   ds,dx
@end_s32um16:
  ret
aud_s32_to_usm16 endp

aud_s32_to_s8 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32s8

  mov   dx,ds
  lds   esi,dest
@lp_s32s8:
  mov   eax,es:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_s328
    mov   eax,1FFFFFFFh
    jmp   @out_s328
  @na_s328:
  cmp   eax,0E0000001h
  jnl   @out_s328
    mov   eax,0E0000001h
@out_s328:
  add   eax,eax

  shr   eax,24

  mov   ds:[esi],al
  add   edi,4
  inc   esi
  dec   ecx
  jnz   @lp_s32s8
  mov   ds,dx
@end_s32s8:
  ret
aud_s32_to_s8 endp

aud_s32_to_sm8 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32m8

  mov   dx,ds
  lds   esi,dest
@lp_s32m8:
  mov   eax,es:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_s32m8_1
    mov   eax,1FFFFFFFh
    jmp   @out_s32m8_1
  @na_s32m8_1:
  cmp   eax,0E0000001h
  jnl   @out_s32m8_1
    mov   eax,0E0000001h
@out_s32m8_1:

  mov ebx,es:[edi+4]

  cmp   ebx,1FFFFFFFh
  jng   @na_s32m8_2
    mov   ebx,1FFFFFFFh
    jmp   @out_s32m8_2
  @na_s32m8_2:
  cmp   ebx,0E0000001h
  jnl   @out_s32m8_2
    mov   ebx,0E0000001h
@out_s32m8_2:

  add   eax,ebx
  shr   eax,24
  mov   ds:[esi],al
  add   edi,8
  inc   esi
  dec   ecx
  jnz   @lp_s32m8
  mov   ds,dx
@end_s32m8:
  ret
aud_s32_to_sm8 endp

aud_s32_to_us8 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32u8

  mov   dx,ds
  lds   esi,dest
@lp_s32u8:
  mov   eax,es:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_us328
    mov   eax,1FFFFFFFh
    jmp   @out_us328
  @na_us328:
  cmp   eax,0E0000001h
  jnl   @out_us328
    mov   eax,0E0000001h
@out_us328:
  add   eax,eax
  shr   eax,24

  add   al,80h
  mov   ds:[esi],al
  add   edi,4
  inc   esi
  dec   ecx
  jnz   @lp_s32u8
  mov   ds,dx
@end_s32u8:
  ret
aud_s32_to_us8 endp

aud_s32_to_usm8 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_s32um8

  mov   dx,ds
  lds   esi,dest
  xor   eax,eax
  xor   ebx,ebx
@lp_s32um8:
  mov   eax,es:[edi]

  cmp   eax,1FFFFFFFh
  jng   @na_us32m8_1
    mov   eax,1FFFFFFFh
    jmp   @out_us32m8_1
  @na_us32m8_1:
  cmp   eax,0E0000001h
  jnl   @out_us32m8_1
    mov   eax,0E0000001h
@out_us32m8_1:

  mov ebx,es:[edi+4]

  cmp   ebx,1FFFFFFFh
  jng   @na_us32m8_2
    mov   ebx,1FFFFFFFh
    jmp   @out_us32m8_2
  @na_us32m8_2:
  cmp   ebx,0E0000001h
  jnl   @out_us32m8_2
    mov   ebx,0E0000001h
@out_us32m8_2:

  add   eax,ebx
  shr   eax,24
  add   al,80h

  mov   ds:[esi],al
  add   edi,8
  inc   esi
  dec   ecx
  jnz   @lp_s32um8
  mov   ds,dx
@end_s32um8:
  ret
aud_s32_to_usm8 endp

delta8_to_16 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_d88

  mov   dx,ds
  lds   esi,dest
  mov   al,0
  mov   bl,0
@lp_d88:
  add   al,es:[edi]
  mov   bh,al
  mov   es:[esi],bx
  inc   edi
  add   esi,2
  dec   ecx
  jnz   @lp_d88
  mov   ds,dx
@end_d88:
  ret
delta8_to_16 endp

delta16_to_16 proc
arg source:pword,dest:pword,samples:dword
  les   edi,source
  mov   ecx,samples
  or    ecx,ecx
  jz    @end_d816

  mov   dx,ds
  lds   esi,dest
  mov   bx,0
@lp_d816:
  mov   al,es:[edi]
  cbw
  add   bx,ax
  mov   es:[esi],bx
  inc   edi
  add   esi,2
  dec   ecx
  jnz   @lp_d816
  mov   ds,dx
@end_d816:
  ret
delta16_to_16 endp

ends
end
